Index: branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HeuristicLab.Hive.Client.Console-3.2.csproj
===================================================================
--- branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HeuristicLab.Hive.Client.Console-3.2.csproj	(revision 3580)
+++ branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HeuristicLab.Hive.Client.Console-3.2.csproj	(revision 3931)
@@ -202,6 +202,4 @@
     <None Include="Properties\DataSources\Calendar.Appointment.datasource" />
     <None Include="Resources\shutdown-icon.png" />
-    <None Include="Service References\ClientService\Calendar.xsd" />
-    <None Include="Service References\ClientService\System.Drawing.xsd" />
   </ItemGroup>
   <ItemGroup>
@@ -213,4 +211,6 @@
   <ItemGroup>
     <None Include="Resources\exit-48.png" />
+    <None Include="Service References\ClientService\Calendar1.xsd" />
+    <None Include="Service References\ClientService\System.Drawing1.xsd" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.cs
===================================================================
--- branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.cs	(revision 3580)
+++ branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsole.cs	(revision 3931)
@@ -187,5 +187,5 @@
     }
 
-    private void UpdateGraph(JobStatus[] jobs)
+    private void UpdateGraph(StatusCommons sc)
     {
       ZedGraphControl zgc = new ZedGraphControl();
@@ -208,5 +208,6 @@
       double done = 0;
 
-      if (jobs.Length == 0)
+      
+      /*if (jobs.Length == 0)
       {
         myPane.AddPieSlice(100, Color.Green, 0.1, "");
@@ -217,11 +218,11 @@
         {
           allProgress += jobs[i].Progress;
-        }
-
-        done = allProgress / jobs.Length;
-
-        myPane.AddPieSlice(done, Color.Green, 0, "");
-        myPane.AddPieSlice(1 - done, Color.Red, 0, "");
-      }
+        } */
+
+        //done = allProgress / jobs.Length;
+
+      myPane.AddPieSlice((sc.FreeCores / (double) sc.TotalCores), Color.Red, 0, "");
+      myPane.AddPieSlice(((sc.TotalCores - sc.FreeCores) / (double)sc.TotalCores), Color.Green, 0, "");
+     // }
       //Hides the slice labels
       PieItem.Default.LabelType = PieLabelType.None;
@@ -586,5 +587,5 @@
         }
 
-        UpdateGraph(sc.Jobs);
+        UpdateGraph(sc);
 
         if (sc.Status == NetworkEnumWcfConnState.Connected || sc.Status == NetworkEnumWcfConnState.Loggedin)
Index: branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/HeuristicLab.Hive.Client.Core.ClientConsoleService.xsd
===================================================================
--- branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/HeuristicLab.Hive.Client.Core.ClientConsoleService.xsd	(revision 3580)
+++ branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/HeuristicLab.Hive.Client.Core.ClientConsoleService.xsd	(revision 3931)
@@ -7,4 +7,5 @@
       <xs:element minOccurs="0" name="ClientGuid" type="ser:guid" />
       <xs:element minOccurs="0" name="ConnectedSince" type="xs:dateTime" />
+      <xs:element minOccurs="0" name="FreeCores" type="xs:int" />
       <xs:element minOccurs="0" name="Jobs" nillable="true" type="tns:ArrayOfJobStatus" />
       <xs:element minOccurs="0" name="JobsAborted" type="xs:int" />
@@ -12,4 +13,5 @@
       <xs:element minOccurs="0" name="JobsFetched" type="xs:int" />
       <xs:element xmlns:q1="http://schemas.datacontract.org/2004/07/HeuristicLab.Hive.Client.Common" minOccurs="0" name="Status" type="q1:NetworkEnum.WcfConnState" />
+      <xs:element minOccurs="0" name="TotalCores" type="xs:int" />
     </xs:sequence>
   </xs:complexType>
Index: branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/Reference.cs
===================================================================
--- branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/Reference.cs	(revision 3580)
+++ branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/Reference.cs	(revision 3931)
@@ -2,5 +2,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:2.0.50727.3082
+//     Runtime Version:2.0.50727.4927
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -31,4 +31,7 @@
         
         [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private int FreeCoresField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
         private HeuristicLab.Hive.Client.Console.ClientService.JobStatus[] JobsField;
         
@@ -44,4 +47,7 @@
         [System.Runtime.Serialization.OptionalFieldAttribute()]
         private HeuristicLab.Hive.Client.Console.ClientService.NetworkEnumWcfConnState StatusField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private int TotalCoresField;
         
         [global::System.ComponentModel.BrowsableAttribute(false)]
@@ -82,4 +88,17 @@
         
         [System.Runtime.Serialization.DataMemberAttribute()]
+        public int FreeCores {
+            get {
+                return this.FreeCoresField;
+            }
+            set {
+                if ((this.FreeCoresField.Equals(value) != true)) {
+                    this.FreeCoresField = value;
+                    this.RaisePropertyChanged("FreeCores");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
         public HeuristicLab.Hive.Client.Console.ClientService.JobStatus[] Jobs {
             get {
@@ -142,4 +161,17 @@
                     this.StatusField = value;
                     this.RaisePropertyChanged("Status");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public int TotalCores {
+            get {
+                return this.TotalCoresField;
+            }
+            set {
+                if ((this.TotalCoresField.Equals(value) != true)) {
+                    this.TotalCoresField = value;
+                    this.RaisePropertyChanged("TotalCores");
                 }
             }
Index: branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/Reference.svcmap
===================================================================
--- branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/Reference.svcmap	(revision 3580)
+++ branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/Reference.svcmap	(revision 3931)
@@ -26,6 +26,6 @@
     <MetadataFile FileName="HeuristicLab.Hive.Client.Core.ClientConsoleService.xsd" MetadataType="Schema" ID="36748734-59b6-4ba4-950d-66ca1a4fc8bb" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
     <MetadataFile FileName="HeuristicLab.Hive.Client.Common.xsd" MetadataType="Schema" ID="0c1369fa-d4cc-4149-b202-00da9dd35972" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
-    <MetadataFile FileName="Calendar.xsd" MetadataType="Schema" ID="09fa9f67-e082-4dcb-9c41-a7a3f0fb7aef" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
-    <MetadataFile FileName="System.Drawing.xsd" MetadataType="Schema" ID="70cfc9bf-b4a8-419b-8c1f-379c0d78f9d2" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
+    <MetadataFile FileName="Calendar1.xsd" MetadataType="Schema" ID="5ec19e4e-fed1-451d-971e-01b8df8dcb0a" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
+    <MetadataFile FileName="System.Drawing1.xsd" MetadataType="Schema" ID="2aa97a8b-a12e-47ca-8bb7-93a3404f40e5" SourceId="1" SourceUrl="net.tcp://127.0.0.1:8000/ClientConsole/mex" />
   </Metadata>
   <Extensions>
Index: branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/configuration.svcinfo
===================================================================
--- branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/configuration.svcinfo	(revision 3580)
+++ branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/configuration.svcinfo	(revision 3931)
@@ -6,5 +6,5 @@
   </bindings>
   <endpoints>
-    <endpoint normalizedDigest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;net.tcp://127.0.0.1:8000/ClientConsole/ClientConsoleCommunicator&quot; binding=&quot;netTcpBinding&quot; bindingConfiguration=&quot;NetTcpBinding_IClientConsoleCommunicator&quot; contract=&quot;ClientService.IClientConsoleCommunicator&quot; name=&quot;NetTcpBinding_IClientConsoleCommunicator&quot;&gt;&lt;identity&gt;&lt;userPrincipalName value=&quot;mse08004@fhs-hagenberg.ac.at&quot; /&gt;&lt;/identity&gt;&lt;/Data&gt;" digest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;net.tcp://127.0.0.1:8000/ClientConsole/ClientConsoleCommunicator&quot; binding=&quot;netTcpBinding&quot; bindingConfiguration=&quot;NetTcpBinding_IClientConsoleCommunicator&quot; contract=&quot;ClientService.IClientConsoleCommunicator&quot; name=&quot;NetTcpBinding_IClientConsoleCommunicator&quot;&gt;&lt;identity&gt;&lt;userPrincipalName value=&quot;mse08004@fhs-hagenberg.ac.at&quot; /&gt;&lt;/identity&gt;&lt;/Data&gt;" contractName="ClientService.IClientConsoleCommunicator" name="NetTcpBinding_IClientConsoleCommunicator" />
+    <endpoint normalizedDigest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;net.tcp://127.0.0.1:8000/ClientConsole/ClientConsoleCommunicator&quot; binding=&quot;netTcpBinding&quot; bindingConfiguration=&quot;NetTcpBinding_IClientConsoleCommunicator&quot; contract=&quot;ClientService.IClientConsoleCommunicator&quot; name=&quot;NetTcpBinding_IClientConsoleCommunicator&quot;&gt;&lt;identity&gt;&lt;userPrincipalName value=&quot;semteX-PC\semteX&quot; /&gt;&lt;/identity&gt;&lt;/Data&gt;" digest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;net.tcp://127.0.0.1:8000/ClientConsole/ClientConsoleCommunicator&quot; binding=&quot;netTcpBinding&quot; bindingConfiguration=&quot;NetTcpBinding_IClientConsoleCommunicator&quot; contract=&quot;ClientService.IClientConsoleCommunicator&quot; name=&quot;NetTcpBinding_IClientConsoleCommunicator&quot;&gt;&lt;identity&gt;&lt;userPrincipalName value=&quot;semteX-PC\semteX&quot; /&gt;&lt;/identity&gt;&lt;/Data&gt;" contractName="ClientService.IClientConsoleCommunicator" name="NetTcpBinding_IClientConsoleCommunicator" />
   </endpoints>
 </configurationSnapshot>
Index: branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/configuration91.svcinfo
===================================================================
--- branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/configuration91.svcinfo	(revision 3580)
+++ branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/configuration91.svcinfo	(revision 3931)
@@ -1,4 +1,4 @@
 <?xml version="1.0" encoding="utf-8"?>
-<SavedWcfConfigurationInformation xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" Version="9.1" CheckSum="LJHqHAg9UO+arib7mQMPUcNSFqQ=">
+<SavedWcfConfigurationInformation xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" Version="9.1" CheckSum="BEhVTwOR+7957ZuwDJOXr3mn9MQ=">
   <bindingConfigurations>
     <bindingConfiguration bindingType="netTcpBinding" name="NetTcpBinding_IClientConsoleCommunicator">
@@ -93,4 +93,16 @@
         <property path="/security/transport/protectionLevel" isComplexType="false" isExplicitlyDefined="true" clrType="System.Net.Security.ProtectionLevel, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
           <serializedValue>EncryptAndSign</serializedValue>
+        </property>
+        <property path="/security/transport/extendedProtectionPolicy" isComplexType="true" isExplicitlyDefined="false" clrType="System.Security.Authentication.ExtendedProtection.Configuration.ExtendedProtectionPolicyElement, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+          <serializedValue>System.Security.Authentication.ExtendedProtection.Configuration.ExtendedProtectionPolicyElement</serializedValue>
+        </property>
+        <property path="/security/transport/extendedProtectionPolicy/policyEnforcement" isComplexType="false" isExplicitlyDefined="false" clrType="System.Security.Authentication.ExtendedProtection.PolicyEnforcement, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+          <serializedValue>Never</serializedValue>
+        </property>
+        <property path="/security/transport/extendedProtectionPolicy/protectionScenario" isComplexType="false" isExplicitlyDefined="false" clrType="System.Security.Authentication.ExtendedProtection.ProtectionScenario, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+          <serializedValue>TransportSelected</serializedValue>
+        </property>
+        <property path="/security/transport/extendedProtectionPolicy/customServiceNames" isComplexType="true" isExplicitlyDefined="false" clrType="System.Security.Authentication.ExtendedProtection.Configuration.ServiceNameElementCollection, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+          <serializedValue>(Collection)</serializedValue>
         </property>
         <property path="/security/message" isComplexType="true" isExplicitlyDefined="false" clrType="System.ServiceModel.Configuration.MessageSecurityOverTcpElement, System.ServiceModel, Version=3.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
@@ -137,5 +149,5 @@
         </property>
         <property path="/identity/userPrincipalName/value" isComplexType="false" isExplicitlyDefined="true" clrType="System.String, mscorlib, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
-          <serializedValue>mse08004@fhs-hagenberg.ac.at</serializedValue>
+          <serializedValue>semteX-PC\semteX</serializedValue>
         </property>
         <property path="/identity/servicePrincipalName" isComplexType="true" isExplicitlyDefined="false" clrType="System.ServiceModel.Configuration.ServicePrincipalNameElement, System.ServiceModel, Version=3.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
Index: branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/service.wsdl
===================================================================
--- branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/service.wsdl	(revision 3580)
+++ branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/Service References/ClientService/service.wsdl	(revision 3931)
@@ -1,4 +1,4 @@
 ﻿<?xml version="1.0" encoding="utf-8"?>
-<wsdl:definitions xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:wsap="http://schemas.xmlsoap.org/ws/2004/08/addressing/policy" xmlns:wsp="http://schemas.xmlsoap.org/ws/2004/09/policy" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msc="http://schemas.microsoft.com/ws/2005/12/wsdl/contract" xmlns:tns="http://tempuri.org/" xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/" xmlns:wsa10="http://www.w3.org/2005/08/addressing" xmlns:wsam="http://www.w3.org/2007/05/addressing/metadata" name="ClientConsoleCommunicator" targetNamespace="http://tempuri.org/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
+<wsdl:definitions xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:wsap="http://schemas.xmlsoap.org/ws/2004/08/addressing/policy" xmlns:wsp="http://schemas.xmlsoap.org/ws/2004/09/policy" xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:msc="http://schemas.microsoft.com/ws/2005/12/wsdl/contract" xmlns:tns="http://tempuri.org/" xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/" xmlns:wsa10="http://www.w3.org/2005/08/addressing" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:wsam="http://www.w3.org/2007/05/addressing/metadata" name="ClientConsoleCommunicator" targetNamespace="http://tempuri.org/" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
   <wsp:Policy wsu:Id="NetTcpBinding_IClientConsoleCommunicator_policy">
     <wsp:ExactlyOne>
@@ -190,5 +190,5 @@
         <wsa10:Address>net.tcp://127.0.0.1:8000/ClientConsole/ClientConsoleCommunicator</wsa10:Address>
         <Identity xmlns="http://schemas.xmlsoap.org/ws/2006/02/addressingidentity">
-          <Upn>mse08004@fhs-hagenberg.ac.at</Upn>
+          <Upn>semteX-PC\semteX</Upn>
         </Identity>
       </wsa10:EndpointReference>
Index: branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/app.config
===================================================================
--- branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/app.config	(revision 3580)
+++ branches/3.2/sources/HeuristicLab.Hive.Client.Console/3.2/app.config	(revision 3931)
@@ -27,5 +27,7 @@
                                           enabled="false" />
                                    <security mode="Transport">
-                                          <transport clientCredentialType="Windows" protectionLevel="EncryptAndSign" />
+                                          <transport clientCredentialType="Windows" protectionLevel="EncryptAndSign">
+                                                 <extendedProtectionPolicy policyEnforcement="Never" />
+                                          </transport>
                                           <message clientCredentialType="Windows" />
                                    </security>
@@ -38,5 +40,5 @@
                             contract="ClientService.IClientConsoleCommunicator" name="NetTcpBinding_IClientConsoleCommunicator">
                             <identity>
-                                   <userPrincipalName value="mse08004@fhs-hagenberg.ac.at" />
+                                   <userPrincipalName value="semteX-PC\semteX" />
                             </identity>
                      </endpoint>