Index: /branches/HeuristicLab.Services.Authentication Prototype/HeuristicLab.Services.Authentication Prototyp.vsmdi
===================================================================
--- /branches/HeuristicLab.Services.Authentication Prototype/HeuristicLab.Services.Authentication Prototyp.vsmdi	(revision 3939)
+++ /branches/HeuristicLab.Services.Authentication Prototype/HeuristicLab.Services.Authentication Prototyp.vsmdi	(revision 3940)
@@ -1,4 +1,10 @@
 ﻿<?xml version="1.0" encoding="UTF-8"?>
 <TestLists xmlns="http://microsoft.com/schemas/VisualStudio/TeamTest/2006">
+  <TestList name="HeuristicLabUserTestList" id="1ebca506-0e3e-4cc3-800e-9905f9a66bd2" parentListId="8c43106b-9dc1-4907-a29f-aa66a61bf5b6">
+    <Description>just first test for HeuristicLabUser</Description>
+    <TestLinks>
+      <TestLink id="def90666-533d-bda5-8a29-fde7f290333f" name="createDBTest" storage="unittests\bin\debug\unittests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel,   PublicKeyToken=b03f5f7f11d50a3a" />
+    </TestLinks>
+  </TestList>
   <TestList name="Testlisten" id="8c43106b-9dc1-4907-a29f-aa66a61bf5b6">
     <RunConfiguration id="3cde0e70-9e75-4b76-a987-9e1d702958f0" name="Lokaler Testlauf" storage="localtestrun.testrunconfig" type="Microsoft.VisualStudio.TestTools.Common.TestRunConfiguration, Microsoft.VisualStudio.QualityTools.Common,   PublicKeyToken=b03f5f7f11d50a3a" />
Index: /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DataClasses.cs
===================================================================
--- /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DataClasses.cs	(revision 3939)
+++ /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DataClasses.cs	(revision 3940)
@@ -1,5 +1,114 @@
+using System;
 using System.Web.Security;
+
 namespace Persistence {
   partial class HeuristicLabUser : MembershipUser {
+    public override bool ChangePassword(string oldPassword, string newPassword) {
+      if (oldPassword == null) {
+        throw new ArgumentNullException("oldPassword");
+      }
+      if (newPassword == null) {
+        throw new ArgumentNullException("newPassword");
+      }
+      if (oldPassword.Length == 0) {
+        throw new ArgumentException("Parameter oldPassword must not be empty!");
+      }
+      if (newPassword.Length == 0) {
+        throw new ArgumentException("Parameter newPassword must not be empty!");
+      }
+
+      if (Password.CompareTo(oldPassword) == 0) {
+        Password = newPassword;
+        return true;
+      } else {
+        return false;
+      }
+    }
+
+    public override bool ChangePasswordQuestionAndAnswer(string password, string newPasswordQuestion, string newPasswordAnswer) {
+      if (password == null) {
+        throw new ArgumentNullException("password");
+      }
+      if (newPasswordQuestion == null) {
+        throw new ArgumentNullException("newPasswordQuestion");
+      }
+      if (newPasswordAnswer == null) {
+        throw new ArgumentNullException("newPasswordAnswer");
+      }
+      if (password.Length == 0) {
+        throw new ArgumentException("Parameter password must not be empty!");
+      }
+      if (newPasswordQuestion.Length == 0) {
+        throw new ArgumentException("Parameter newPasswordQuestion must not be empty!");
+      }
+      if (newPasswordAnswer.Length == 0) {
+        throw new ArgumentException("Parameter newPasswordAnswer must not be empty!");
+      }
+
+      if (Password.CompareTo(password) == 0) {
+        _PasswordQuestion = newPasswordQuestion;
+        PasswordAnswer = newPasswordAnswer;
+        return true;
+      } else {
+        return false;
+      }
+    }
+
+    public override string GetPassword() {
+      return Password;
+    }
+
+    //
+    // Summary:
+    //     Gets the password for the membership user from the membership data store.
+    //
+    // Parameters:
+    //   passwordAnswer:
+    //     The password answer for the membership user.
+    //
+    // Returns:
+    //     The password for the membership user.
+    public override string GetPassword(string passwordAnswer) {
+      throw new NotImplementedException();
+    }
+
+    //
+    // Summary:
+    //     Resets a user's password to a new, automatically generated password.
+    //
+    // Returns:
+    //     The new password for the membership user.
+    public override string ResetPassword() {
+      throw new NotImplementedException();
+    }
+
+    //
+    // Summary:
+    //     Resets a user's password to a new, automatically generated password.
+    //
+    // Parameters:
+    //   passwordAnswer:
+    //     The password answer for the membership user.
+    //
+    // Returns:
+    //     The new password for the membership user.
+    public override string ResetPassword(string passwordAnswer) {
+      throw new NotImplementedException();
+    }
+
+    public override string ToString() {
+      return UserName;
+    }
+
+    //
+    // Summary:
+    //     Clears the locked-out state of the user so that the membership user can be
+    //     validated.
+    //
+    // Returns:
+    //     true if the membership user was successfully unlocked; otherwise, false.
+    public override bool UnlockUser() {
+      throw new NotImplementedException();
+    }
   }
 }
Index: /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DataClasses.dbml
===================================================================
--- /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DataClasses.dbml	(revision 3939)
+++ /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DataClasses.dbml	(revision 3940)
@@ -3,5 +3,12 @@
   <Table Name="" Member="HeuristicLabUsers">
     <Type Name="HeuristicLabUser">
-      <Column Member="Comment" Modifier="Virtual" Type="System.String" CanBeNull="false" />
+      <Column Name="UserName" Modifier="Override" Type="System.String" IsReadOnly="true" CanBeNull="false" />
+      <Column Name="Password" Type="System.String" CanBeNull="false" />
+      <Column Name="PasswordQuestion" Modifier="Override" Type="System.String" IsReadOnly="true" CanBeNull="false" />
+      <Column Name="LastPasswordChangedDate" Modifier="Override" Type="System.DateTime" IsReadOnly="true" CanBeNull="false" />
+      <Column Name="Email" Modifier="Override" Type="System.String" CanBeNull="false" />
+      <Column Name="Comment" Modifier="Override" Type="System.String" CanBeNull="false" />
+      <Column Name="PasswordAnswer" Type="System.String" CanBeNull="false" />
+      <Column Member="id" AutoSync="Never" Type="System.Int64" IsReadOnly="true" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" UpdateCheck="Always" />
     </Type>
   </Table>
Index: /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DataClasses.dbml.layout
===================================================================
--- /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DataClasses.dbml.layout	(revision 3939)
+++ /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DataClasses.dbml.layout	(revision 3940)
@@ -3,8 +3,8 @@
   <DataContextMoniker Name="/DataClassesDataContext" />
   <nestedChildShapes>
-    <classShape Id="d272bb7d-2ecc-4bb7-851f-8e1ecee6fdbd" absoluteBounds="3.625, 1.875, 2, 1.0016910807291666">
+    <classShape Id="d272bb7d-2ecc-4bb7-851f-8e1ecee6fdbd" absoluteBounds="3.625, 1.875, 2, 2.3478011067708326">
       <DataClassMoniker Name="/DataClassesDataContext/HeuristicLabUser" />
       <nestedChildShapes>
-        <elementListCompartment Id="cb578485-5602-4fe8-96b8-63d240ffa2d9" absoluteBounds="3.64, 2.335, 1.9700000000000002, 0.44169108072916663" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+        <elementListCompartment Id="cb578485-5602-4fe8-96b8-63d240ffa2d9" absoluteBounds="3.64, 2.335, 1.9700000000000002, 1.7878011067708333" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
       </nestedChildShapes>
     </classShape>
Index: /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DatabaseUtil.cs
===================================================================
--- /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DatabaseUtil.cs	(revision 3940)
+++ /branches/HeuristicLab.Services.Authentication Prototype/Persistence/DatabaseUtil.cs	(revision 3940)
@@ -0,0 +1,14 @@
+﻿namespace Persistence {
+  /// <summary>
+  /// 
+  /// </summary>
+  public class DatabaseUtil {
+    /// <summary>
+    /// 
+    /// </summary>
+    /// <returns></returns>
+    public static DataClassesDataContext createDataClassesDataContext() {
+      return new Persistence.DataClassesDataContext(@"C:\TEMP\HeuristicLabTemp.mdf");
+    }
+  }
+}
Index: /branches/HeuristicLab.Services.Authentication Prototype/Persistence/Persistence.csproj
===================================================================
--- /branches/HeuristicLab.Services.Authentication Prototype/Persistence/Persistence.csproj	(revision 3939)
+++ /branches/HeuristicLab.Services.Authentication Prototype/Persistence/Persistence.csproj	(revision 3940)
@@ -50,20 +50,9 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="DatabaseUtil.cs" />
     <Compile Include="DataClasses.cs">
       <DependentUpon>DataClasses.dbml</DependentUpon>
     </Compile>
-    <Compile Include="HeuristicLabUser.designer.cs">
-      <AutoGen>True</AutoGen>
-      <DesignTime>True</DesignTime>
-      <DependentUpon>HeuristicLabUser.dbml</DependentUpon>
-    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="HeuristicLabUser.dbml">
-      <Generator>MSLinqToSQLGenerator</Generator>
-      <LastGenOutput>HeuristicLabUser.designer.cs</LastGenOutput>
-      <SubType>Designer</SubType>
-    </None>
   </ItemGroup>
   <ItemGroup>
@@ -71,11 +60,7 @@
   </ItemGroup>
   <ItemGroup>
-    <None Include="ClassDiagram1.cd" />
     <None Include="DataClasses.dbml">
       <Generator>MSLinqToSQLGenerator</Generator>
       <SubType>Designer</SubType>
-    </None>
-    <None Include="HeuristicLabUser.dbml.layout">
-      <DependentUpon>HeuristicLabUser.dbml</DependentUpon>
     </None>
   </ItemGroup>
Index: /branches/HeuristicLab.Services.Authentication Prototype/UnitTests/HeuristicLabUserTest.cs
===================================================================
--- /branches/HeuristicLab.Services.Authentication Prototype/UnitTests/HeuristicLabUserTest.cs	(revision 3940)
+++ /branches/HeuristicLab.Services.Authentication Prototype/UnitTests/HeuristicLabUserTest.cs	(revision 3940)
@@ -0,0 +1,326 @@
+﻿using Persistence;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using System;
+
+namespace UnitTests {
+  /// <summary>
+  ///This is a test class for HeuristicLabUserTest and is intended
+  ///to contain all HeuristicLabUserTest Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class HeuristicLabUserTest {
+    private TestContext testContextInstance;
+
+    private Persistence.DataClassesDataContext db;
+
+    public HeuristicLabUserTest() {
+      db = Persistence.DatabaseUtil.createDataClassesDataContext();
+    }
+
+    /// <summary>
+    /// creates a local database for all other test methods
+    /// </summary>
+    [TestMethod()]
+    public void createDBTest() {
+      if (db.DatabaseExists()) {
+        Console.WriteLine("Deleting old database...");
+        db.DeleteDatabase();
+        Console.WriteLine("Deleted old database!");
+      }
+      Console.WriteLine("Creating new database...");
+      db.CreateDatabase();
+      Console.WriteLine("Created new database!");
+    }
+
+    /// <summary>
+    /// inserts a new user into the database
+    /// </summary>
+    [TestMethod()]
+    public void addUserTest() {
+      //Assert.IsNotNull(db);
+
+      //Persistence.HeuristicLabUser user = new HeuristicLabUser();
+      //user.UserName = "TEST";
+      //db.HeuristicLabUsers.InsertOnSubmit(user);
+      //db.SubmitChanges();
+
+//      db.HeuristicLabUsers.
+    }
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for UserName
+    ///</summary>
+    [TestMethod()]
+    public void UserNameTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string actual;
+      actual = target.UserName;
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for PasswordQuestion
+    ///</summary>
+    [TestMethod()]
+    public void PasswordQuestionTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string actual;
+      actual = target.PasswordQuestion;
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for PasswordAnswer
+    ///</summary>
+    [TestMethod()]
+    public void PasswordAnswerTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string expected = string.Empty; // TODO: Initialize to an appropriate value
+      string actual;
+      target.PasswordAnswer = expected;
+      actual = target.PasswordAnswer;
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for Password
+    ///</summary>
+    [TestMethod()]
+    public void PasswordTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string expected = string.Empty; // TODO: Initialize to an appropriate value
+      string actual;
+      target.Password = expected;
+      actual = target.Password;
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for LastPasswordChangedDate
+    ///</summary>
+    [TestMethod()]
+    public void LastPasswordChangedDateTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      DateTime actual;
+      actual = target.LastPasswordChangedDate;
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for Email
+    ///</summary>
+    [TestMethod()]
+    public void EmailTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string expected = string.Empty; // TODO: Initialize to an appropriate value
+      string actual;
+      target.Email = expected;
+      actual = target.Email;
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for Comment
+    ///</summary>
+    [TestMethod()]
+    public void CommentTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string expected = string.Empty; // TODO: Initialize to an appropriate value
+      string actual;
+      target.Comment = expected;
+      actual = target.Comment;
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for UnlockUser
+    ///</summary>
+    [TestMethod()]
+    public void UnlockUserTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      bool expected = false; // TODO: Initialize to an appropriate value
+      bool actual;
+      actual = target.UnlockUser();
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for ToString
+    ///</summary>
+    [TestMethod()]
+    public void ToStringTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string expected = string.Empty; // TODO: Initialize to an appropriate value
+      string actual;
+      actual = target.ToString();
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for SendPropertyChanging
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("Persistence.dll")]
+    public void SendPropertyChangingTest() {
+      HeuristicLabUser_Accessor target = new HeuristicLabUser_Accessor(); // TODO: Initialize to an appropriate value
+      target.SendPropertyChanging();
+      Assert.Inconclusive("A method that does not return a value cannot be verified.");
+    }
+
+    /// <summary>
+    ///A test for SendPropertyChanged
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("Persistence.dll")]
+    public void SendPropertyChangedTest() {
+      HeuristicLabUser_Accessor target = new HeuristicLabUser_Accessor(); // TODO: Initialize to an appropriate value
+      string propertyName = string.Empty; // TODO: Initialize to an appropriate value
+      target.SendPropertyChanged(propertyName);
+      Assert.Inconclusive("A method that does not return a value cannot be verified.");
+    }
+
+    /// <summary>
+    ///A test for ResetPassword
+    ///</summary>
+    [TestMethod()]
+    public void ResetPasswordTest1() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string expected = string.Empty; // TODO: Initialize to an appropriate value
+      string actual;
+      actual = target.ResetPassword();
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for ResetPassword
+    ///</summary>
+    [TestMethod()]
+    public void ResetPasswordTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string passwordAnswer = string.Empty; // TODO: Initialize to an appropriate value
+      string expected = string.Empty; // TODO: Initialize to an appropriate value
+      string actual;
+      actual = target.ResetPassword(passwordAnswer);
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for GetPassword
+    ///</summary>
+    [TestMethod()]
+    public void GetPasswordTest1() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string passwordAnswer = string.Empty; // TODO: Initialize to an appropriate value
+      string expected = string.Empty; // TODO: Initialize to an appropriate value
+      string actual;
+      actual = target.GetPassword(passwordAnswer);
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for GetPassword
+    ///</summary>
+    [TestMethod()]
+    public void GetPasswordTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string expected = string.Empty; // TODO: Initialize to an appropriate value
+      string actual;
+      actual = target.GetPassword();
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for ChangePasswordQuestionAndAnswer
+    ///</summary>
+    [TestMethod()]
+    public void ChangePasswordQuestionAndAnswerTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string password = string.Empty; // TODO: Initialize to an appropriate value
+      string newPasswordQuestion = string.Empty; // TODO: Initialize to an appropriate value
+      string newPasswordAnswer = string.Empty; // TODO: Initialize to an appropriate value
+      bool expected = false; // TODO: Initialize to an appropriate value
+      bool actual;
+      actual = target.ChangePasswordQuestionAndAnswer(password, newPasswordQuestion, newPasswordAnswer);
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for ChangePassword
+    ///</summary>
+    [TestMethod()]
+    public void ChangePasswordTest() {
+      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
+      string oldPassword = string.Empty; // TODO: Initialize to an appropriate value
+      string newPassword = string.Empty; // TODO: Initialize to an appropriate value
+      bool expected = false; // TODO: Initialize to an appropriate value
+      bool actual;
+      actual = target.ChangePassword(oldPassword, newPassword);
+      Assert.AreEqual(expected, actual);
+      Assert.Inconclusive("Verify the correctness of this test method.");
+    }
+
+    /// <summary>
+    ///A test for HeuristicLabUser Constructor
+    ///</summary>
+    [TestMethod()]
+    public void HeuristicLabUserConstructorTest() {
+      HeuristicLabUser target = new HeuristicLabUser();
+      Assert.Inconclusive("TODO: Implement code to verify target");
+    }
+  }
+}
Index: /branches/HeuristicLab.Services.Authentication Prototype/UnitTests/Test References/Persistence.accessor
===================================================================
--- /branches/HeuristicLab.Services.Authentication Prototype/UnitTests/Test References/Persistence.accessor	(revision 3940)
+++ /branches/HeuristicLab.Services.Authentication Prototype/UnitTests/Test References/Persistence.accessor	(revision 3940)
@@ -0,0 +1,2 @@
+Persistence.dll
+Desktop
Index: /branches/HeuristicLab.Services.Authentication Prototype/UnitTests/UnitTests.csproj
===================================================================
--- /branches/HeuristicLab.Services.Authentication Prototype/UnitTests/UnitTests.csproj	(revision 3939)
+++ /branches/HeuristicLab.Services.Authentication Prototype/UnitTests/UnitTests.csproj	(revision 3940)
@@ -39,4 +39,10 @@
     </Reference>
     <Reference Include="System.Data" />
+    <Reference Include="System.Data.DataSetExtensions">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data.Linq">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
     <Reference Include="System.Runtime.Serialization">
       <RequiredTargetFramework>3.0</RequiredTargetFramework>
@@ -54,4 +60,5 @@
     <Compile Include="HeuristicLabMembershipProviderTest.cs" />
     <Compile Include="HeuristicLabRoleProviderTest.cs" />
+    <Compile Include="HeuristicLabUserTest.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
@@ -69,4 +76,7 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <Shadow Include="Test References\Persistence.accessor" />
+  </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 